#ifndef __LCD_H
#define __LCD_H

#include <delays.h>
#include <p18cxxx.h>

#define ENDIAN   LOWER          //0 = 0:3 *** 1 = 4:7

#define LCD_PORT LATD               //LCD DATA PORT
#define LCD_TRIS TRISD              //LCD DATA DIRECTION PORT
#define LCD_DAT  PORTD              //LCD INPUT DATA VALUES

#define LCD_RS   LATDbits.LATD4     //LCD Command/Data Control
#define LCD_E    LATDbits.LATD5     //LCD Enable Line
//#define LCD_RW   LATBbits.LATB6     //LCD Read/Write Control

#define LCD_TRIS_RS TRISDbits.TRISD4
#define LCD_TRIS_E  TRISDbits.TRISD5
//#define LCD_TRIS_RW TRISBbits.TRISB4

#define LINE1 0x80
#define LINE2 0xC0
#define LINE3 0x94  
#define LINE4 0xD4

#define CMD 0
#define TXT 1

#define LOWER 0
#define UPPER 1

#define LOWEND 0x08
#define UPPEND 0x80

#define LOWMSK 0x0F
#define UPPMSK 0xF0

#define DISPLAY 1
#define CURSOR  0

#define RIGHT 1
#define LEFT  0

#define MHz *1000000
#define MYFOSC 20MHz

void WaitLCDBusy(void);
void LCD_Init(void);
void LCD_DATA(unsigned char data,unsigned char type);
void LCD_NYB(unsigned char nyb);
void LCD_STR(unsigned rom char *text);
void LCD_LINE(char line);
void ShiftDisplay(unsigned char DC,unsigned char RL);
void DelayMS(unsigned int ms);
void LCD_CLEAR(unsigned char line);
void LCD_POS(unsigned char line);
void LCD_STR2(unsigned char *text);
extern unsigned char BF;
#endif
